; Especificaciones: Kalidex para ZX Spectrum 16K/48K.
; Descripción general: Ejemplo de un dibujo en alta resolución.
; Longitud: 148 bytes.
; Entrada: Ningún requerimiento.
; Salida: Memoria de pantalla ocupada en parte por un dibujo
; simétrico.
; Registros usados: A, B, C, D, E, H y L.
; Nota importate: El registro doble alternativo H'L' debe ser
; guardado al principio de la rutina y restaurado al final.
org		$7000

CLS		equ $0d6b
DRAW	equ $24ba
OPEN	equ $1601
PLOT	equ $22e5

call	CLS				; Borra la pantalla
ld		a, 2			; Abre
call	OPEN			; canal N. DOS
exx						; Set alternativo
push	hl				; Guarda HL
exx						; Set normal
ld		(iy+87), 0		; Acceso a OVER 0

COMI:
ld		bc, 50			; B=0	C=50
OTRO:
push	bc				; Almacena variable B
call	PLOT1
ld		de, 257			; SGN B=+	SGN C=+
call	DRAW			; DRAW 50,F
call	PLOT1
ld		de, 65281		; SGN B=+	SGN C=-
call	DRAW			; DRAW -50,F
call	PLOT1
ld		de, 511			; SGN B=-	SGN C=+
call	DRAW			; DRAW 50,-F
call	PLOT1
ld		de, 65535		; SGN B=-	SGN C=-
call	DRAW			; DRAW -50,-50
call	PLOT2
ld		de, 257			; SGN B=+	SGN C=+
call	DRAW			; DRAW F,50
call	PLOT2
ld		de, 65281		; SGN B=+	SGN C=-
call	DRAW			; DRAW -F,50
call	PLOT2
ld		de, 511			; SGN B=-	SGN C=+
call	DRAW			; DRAW F,-50
call	PLOT2
ld		de, 65535		; SGN B=-	SGN C=-
call	DRAW			; DRAW -F,-50
pop		bc				; Recupera variable B
ld		a, 251			; Semifila Q-T
in		a, (254)		; Lee teclado
and		8				; ¿Tecla R pulsada?
jr		z, FIN			; Si es así, RET
inc		b				; B=B+1
ld		a, 87			; 87=Límite máximo
cp		b				; Comparación
jr		nz, OTRO		; Si B<>87, OTRO
ld		(iy+87), 3		; Acceso a OVER 1
jr		COMI			; Ve al comienzo

FIN:
exx						; Set alternativo
pop		hl				; Recupera HL
exx						; Set normal
ret						; Retorno a Basic

PLOT1:
pop		hl				; Coge direc. retorno
ld		(23728), hl		; Almacénala en $5cb0
ld		bc, 22656		; B=$58=88	C=$80=128
call	PLOT			; PLOT 128,88
pop		bc				; Coge valor para DRAW
push	bc				; Almacénalo
ld		hl, (23728)		; Recupera dir. retorno
push	hl				; Almacénala en pila
ret

PLOT2:
pop		hl				; Coge direc. retorno
ld		(28670), hl		; Almacénala en $6ffe
call	PLOT1
ld		c, b			; Pasa variable a C
ld		b, 50
ld		hl, (28670)		; Recupera dir. retorno
push	hl				; Almacénala en pila 
ret

end		$7000